import math
from axelrod.action import Action
from axelrod.player import Player
lIIIllIlllIlIIIIII, lIllIIII = Action.C, Action.D
class lIlIlIlll(Player):
    IIllllllIIlIIlllIlll = {
        "stochastic": False,
        "memory_depth": float("inf"),  
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def IllIllIlIIIIIl(lIlIIIlllllI, lllIlllIlIIlII: Player) -> Action:
        if len(lllIlllIlIIlII.history) == 0:
            return lIIIllIlllIlIIIIII
        if not lllIlllIlIIlII.llIllllI:
            return lIllIIII
        IIIllllllIIllI = lllIlllIlIIlII.IIIllllllIIllI + lIlIIIlllllI.IIIllllllIIllI
        llIllllI = lllIlllIlIIlII.llIllllI + lIlIIIlllllI.llIllllI
        if IIIllllllIIllI / llIllllI > lIlIIIlllllI.IIlllllIlIlIII:
            return lIllIIII
        return lIIIllIlllIlIIIIII
class IIIIIllllI(lIlIlIlll):
    lIIlIIIIl = "strategy"
    IIlllllIlIlIII = math.IIIIIllllI